From 835e2cd9406273895eeaf4748eb27d68db5b3d5a Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Wed, 1 Mar 2023 09:52:26 +0100
Subject: [PATCH v1 2/3] doc: Update SQL keywords list for SQL:2023

---
 doc/src/sgml/generate-keywords-table.pl       |  2 +-
 ...eserved.txt => sql2023-02-nonreserved.txt} | 38 +++++++++++++
 ...2-reserved.txt => sql2023-02-reserved.txt} | 56 ++++++++++++++++++-
 ...eserved.txt => sql2023-09-nonreserved.txt} |  0
 ...9-reserved.txt => sql2023-09-reserved.txt} |  4 +-
 ...eserved.txt => sql2023-14-nonreserved.txt} |  6 +-
 ...4-reserved.txt => sql2023-14-reserved.txt} |  0
 7 files changed, 96 insertions(+), 10 deletions(-)
 rename doc/src/sgml/keywords/{sql2011-02-nonreserved.txt => sql2023-02-nonreserved.txt} (88%)
 rename doc/src/sgml/keywords/{sql2011-02-reserved.txt => sql2023-02-reserved.txt} (86%)
 rename doc/src/sgml/keywords/{sql2011-09-nonreserved.txt => sql2023-09-nonreserved.txt} (100%)
 rename doc/src/sgml/keywords/{sql2011-09-reserved.txt => sql2023-09-reserved.txt} (100%)
 rename doc/src/sgml/keywords/{sql2011-14-nonreserved.txt => sql2023-14-nonreserved.txt} (86%)
 rename doc/src/sgml/keywords/{sql2011-14-reserved.txt => sql2023-14-reserved.txt} (100%)

diff --git a/doc/src/sgml/generate-keywords-table.pl b/doc/src/sgml/generate-keywords-table.pl
index b48fac8388..ee44edaa6c 100644
--- a/doc/src/sgml/generate-keywords-table.pl
+++ b/doc/src/sgml/generate-keywords-table.pl
@@ -7,7 +7,7 @@
 use strict;
 use warnings;
 
-my @sql_versions = reverse sort ('1992', '2011', '2016');
+my @sql_versions = reverse sort ('1992', '2016', '2023');
 
 my $srcdir = $ARGV[0];
 
diff --git a/doc/src/sgml/keywords/sql2011-02-nonreserved.txt b/doc/src/sgml/keywords/sql2023-02-nonreserved.txt
similarity index 88%
rename from doc/src/sgml/keywords/sql2011-02-nonreserved.txt
rename to doc/src/sgml/keywords/sql2023-02-nonreserved.txt
index b28a180f0b..48e3d4a7d6 100644
--- a/doc/src/sgml/keywords/sql2011-02-nonreserved.txt
+++ b/doc/src/sgml/keywords/sql2023-02-nonreserved.txt
@@ -19,6 +19,7 @@ CASCADE
 CATALOG
 CATALOG_NAME
 CHAIN
+CHAINING
 CHARACTER_SET_CATALOG
 CHARACTER_SET_NAME
 CHARACTER_SET_SCHEMA
@@ -30,10 +31,12 @@ COLLATION
 COLLATION_CATALOG
 COLLATION_NAME
 COLLATION_SCHEMA
+COLUMNS
 COLUMN_NAME
 COMMAND_FUNCTION
 COMMAND_FUNCTION_CODE
 COMMITTED
+CONDITIONAL
 CONDITION_NUMBER
 CONNECTION
 CONNECTION_NAME
@@ -43,6 +46,7 @@ CONSTRAINT_SCHEMA
 CONSTRAINTS
 CONSTRUCTOR
 CONTINUE
+COPARTITION
 CURSOR_NAME
 DATA
 DATETIME_INTERVAL_CODE
@@ -62,16 +66,21 @@ DISPATCH
 DOMAIN
 DYNAMIC_FUNCTION
 DYNAMIC_FUNCTION_CODE
+ENCODING
 ENFORCED
+ERROR
 EXCLUDE
 EXCLUDING
 EXPRESSION
 FINAL
+FINISH
 FIRST
 FLAG
 FOLLOWING
+FORMAT
 FORTRAN
 FOUND
+FULFILL
 G
 GENERAL
 GENERATED
@@ -93,7 +102,9 @@ INSTEAD
 INVOKER
 ISOLATION
 K
+KEEP
 KEY
+KEYS
 KEY_MEMBER
 KEY_TYPE
 LAST
@@ -104,6 +115,7 @@ M
 MAP
 MATCHED
 MAXVALUE
+MEASURES
 MESSAGE_LENGTH
 MESSAGE_OCTET_LENGTH
 MESSAGE_TEXT
@@ -112,6 +124,7 @@ MORE
 MUMPS
 NAME
 NAMES
+NESTED
 NESTING
 NEXT
 NFC
@@ -119,10 +132,12 @@ NFD
 NFKC
 NFKD
 NORMALIZED
+NULL_ORDERING
 NULLABLE
 NULLS
 NUMBER
 OBJECT
+OCCURRENCE
 OCTETS
 OPTION
 OPTIONS
@@ -130,6 +145,7 @@ ORDERING
 ORDINALITY
 OTHERS
 OUTPUT
+OVERFLOW
 OVERRIDING
 P
 PAD
@@ -141,14 +157,24 @@ PARAMETER_SPECIFIC_NAME
 PARAMETER_SPECIFIC_SCHEMA
 PARTIAL
 PASCAL
+PASS
+PASSING
+PAST
 PATH
+PERMUTE
+PIPE
 PLACING
+PLAN
 PLI
 PRECEDING
 PRESERVE
+PREV
 PRIOR
+PRIVATE
 PRIVILEGES
+PRUNE
 PUBLIC
+QUOTES
 READ
 RELATIVE
 REPEATABLE
@@ -159,12 +185,14 @@ RETURNED_CARDINALITY
 RETURNED_LENGTH
 RETURNED_OCTET_LENGTH
 RETURNED_SQLSTATE
+RETURNING
 ROLE
 ROUTINE
 ROUTINE_CATALOG
 ROUTINE_NAME
 ROUTINE_SCHEMA
 ROW_COUNT
+SCALAR
 SCALE
 SCHEMA
 SCHEMA_NAME
@@ -174,6 +202,7 @@ SCOPE_SCHEMA
 SECTION
 SECURITY
 SELF
+SEMANTICS
 SEQUENCE
 SERIALIZABLE
 SERVER_NAME
@@ -181,17 +210,20 @@ SESSION
 SETS
 SIMPLE
 SIZE
+SORT_DIRECTION
 SOURCE
 SPACE
 SPECIFIC_NAME
 STATE
 STATEMENT
+STRING
 STRUCTURE
 STYLE
 SUBCLASS_ORIGIN
 T
 TABLE_NAME
 TEMPORARY
+THROUGH
 TIES
 TOP_LEVEL_COUNT
 TRANSACTION
@@ -206,14 +238,20 @@ TRIGGER_SCHEMA
 TYPE
 UNBOUNDED
 UNCOMMITTED
+UNCONDITIONAL
 UNDER
+UNMATCHED
 UNNAMED
 USAGE
 USER_DEFINED_TYPE_CATALOG
 USER_DEFINED_TYPE_CODE
 USER_DEFINED_TYPE_NAME
 USER_DEFINED_TYPE_SCHEMA
+UTF16
+UTF32
+UTF8
 VIEW
 WORK
+WRAPPER
 WRITE
 ZONE
diff --git a/doc/src/sgml/keywords/sql2011-02-reserved.txt b/doc/src/sgml/keywords/sql2023-02-reserved.txt
similarity index 86%
rename from doc/src/sgml/keywords/sql2011-02-reserved.txt
rename to doc/src/sgml/keywords/sql2023-02-reserved.txt
index 95f99e7df2..ee364b2470 100644
--- a/doc/src/sgml/keywords/sql2011-02-reserved.txt
+++ b/doc/src/sgml/keywords/sql2023-02-reserved.txt
@@ -1,17 +1,22 @@
 ABS
+ABSENT
+ACOS
 ALL
 ALLOCATE
 ALTER
 AND
 ANY
+ANY_VALUE
 ARE
 ARRAY
 ARRAY_AGG
 ARRAY_MAX_CARDINALITY
 AS
 ASENSITIVE
+ASIN
 ASYMMETRIC
 AT
+ATAN
 ATOMIC
 AUTHORIZATION
 AVG
@@ -24,6 +29,7 @@ BINARY
 BLOB
 BOOLEAN
 BOTH
+BTRIM
 BY
 CALL
 CALLED
@@ -38,6 +44,7 @@ CHAR_LENGTH
 CHARACTER
 CHARACTER_LENGTH
 CHECK
+CLASSIFIER
 CLOB
 CLOSE
 COALESCE
@@ -50,8 +57,11 @@ CONNECT
 CONSTRAINT
 CONTAINS
 CONVERT
+COPY
 CORR
 CORRESPONDING
+COS
+COSH
 COUNT
 COVAR_POP
 COVAR_SAMP
@@ -77,9 +87,11 @@ DATE
 DAY
 DEALLOCATE
 DEC
+DECFLOAT
 DECIMAL
 DECLARE
 DEFAULT
+DEFINE
 DELETE
 DENSE_RANK
 DEREF
@@ -93,6 +105,7 @@ DYNAMIC
 EACH
 ELEMENT
 ELSE
+EMPTY
 END
 END_FRAME
 END_PARTITION
@@ -124,6 +137,7 @@ FUSION
 GET
 GLOBAL
 GRANT
+GREATEST
 GROUP
 GROUPING
 GROUPS
@@ -133,6 +147,7 @@ HOUR
 IDENTITY
 IN
 INDICATOR
+INITIAL
 INNER
 INOUT
 INSENSITIVE
@@ -145,6 +160,18 @@ INTERVAL
 INTO
 IS
 JOIN
+JSON
+JSON_ARRAY
+JSON_ARRAYAGG
+JSON_EXISTS
+JSON_OBJECT
+JSON_OBJECTAGG
+JSON_QUERY
+JSON_SCALAR
+JSON_SERIALIZE
+JSON_TABLE
+JSON_TABLE_PRIMITIVE
+JSON_VALUE
 LAG
 LANGUAGE
 LARGE
@@ -152,15 +179,24 @@ LAST_VALUE
 LATERAL
 LEAD
 LEADING
+LEAST
 LEFT
 LIKE
 LIKE_REGEX
+LISTAGG
 LN
 LOCAL
 LOCALTIME
 LOCALTIMESTAMP
+LOG
+LOG10
 LOWER
+LPAD
+LTRIM
 MATCH
+MATCH_NUMBER
+MATCH_RECOGNIZE
+MATCHES
 MAX
 MEMBER
 MERGE
@@ -186,12 +222,14 @@ NTILE
 NULL
 NULLIF
 NUMERIC
-OCTET_LENGTH
 OCCURRENCES_REGEX
+OCTET_LENGTH
 OF
 OFFSET
 OLD
+OMIT
 ON
+ONE
 ONLY
 OPEN
 OR
@@ -203,6 +241,8 @@ OVERLAPS
 OVERLAY
 PARAMETER
 PARTITION
+PATTERN
+PER
 PERCENT
 PERCENT_RANK
 PERCENTILE_CONT
@@ -217,6 +257,7 @@ PRECISION
 PREPARE
 PRIMARY
 PROCEDURE
+PTF
 RANGE
 RANK
 READS
@@ -245,16 +286,24 @@ ROLLUP
 ROW
 ROW_NUMBER
 ROWS
+RPAD
+RTRIM
+RUNNING
 SAVEPOINT
 SCOPE
 SCROLL
 SEARCH
 SECOND
+SEEK
 SELECT
 SENSITIVE
 SESSION_USER
 SET
+SHOW
 SIMILAR
+SIN
+SINH
+SKIP
 SMALLINT
 SOME
 SPECIFIC
@@ -269,6 +318,7 @@ STATIC
 STDDEV_POP
 STDDEV_SAMP
 SUBMULTISET
+SUBSET
 SUBSTRING
 SUBSTRING_REGEX
 SUCCEEDS
@@ -279,6 +329,8 @@ SYSTEM_TIME
 SYSTEM_USER
 TABLE
 TABLESAMPLE
+TAN
+TANH
 THEN
 TIME
 TIMESTAMP
@@ -291,10 +343,10 @@ TRANSLATE_REGEX
 TRANSLATION
 TREAT
 TRIGGER
-TRUNCATE
 TRIM
 TRIM_ARRAY
 TRUE
+TRUNCATE
 UESCAPE
 UNION
 UNIQUE
diff --git a/doc/src/sgml/keywords/sql2011-09-nonreserved.txt b/doc/src/sgml/keywords/sql2023-09-nonreserved.txt
similarity index 100%
rename from doc/src/sgml/keywords/sql2011-09-nonreserved.txt
rename to doc/src/sgml/keywords/sql2023-09-nonreserved.txt
diff --git a/doc/src/sgml/keywords/sql2011-09-reserved.txt b/doc/src/sgml/keywords/sql2023-09-reserved.txt
similarity index 100%
rename from doc/src/sgml/keywords/sql2011-09-reserved.txt
rename to doc/src/sgml/keywords/sql2023-09-reserved.txt
index 0205485766..92b658d6ef 100644
--- a/doc/src/sgml/keywords/sql2011-09-reserved.txt
+++ b/doc/src/sgml/keywords/sql2023-09-reserved.txt
@@ -2,11 +2,11 @@ DATALINK
 DLNEWCOPY
 DLPREVIOUSCOPY
 DLURLCOMPLETE
-DLURLCOMPLETEWRITE
 DLURLCOMPLETEONLY
+DLURLCOMPLETEWRITE
 DLURLPATH
-DLURLPATHWRITE
 DLURLPATHONLY
+DLURLPATHWRITE
 DLURLSCHEME
 DLURLSERVER
 DLVALUE
diff --git a/doc/src/sgml/keywords/sql2011-14-nonreserved.txt b/doc/src/sgml/keywords/sql2023-14-nonreserved.txt
similarity index 86%
rename from doc/src/sgml/keywords/sql2011-14-nonreserved.txt
rename to doc/src/sgml/keywords/sql2023-14-nonreserved.txt
index 317f651f0e..5ba8fa57d7 100644
--- a/doc/src/sgml/keywords/sql2011-14-nonreserved.txt
+++ b/doc/src/sgml/keywords/sql2023-14-nonreserved.txt
@@ -1,11 +1,9 @@
-ABSENT
 ACCORDING
 BASE64
 BOM
 COLUMNS
 CONTENT
 DOCUMENT
-EMPTY
 ENCODING
 HEX
 ID
@@ -13,10 +11,8 @@ INDENT
 LOCATION
 NAMESPACE
 NIL
-PASSING
 PATH
 PRESERVE
-RETURNING
 SEQUENCE
 STANDALONE
 STRIP
@@ -25,5 +21,5 @@ URI
 VALID
 VERSION
 WHITESPACE
-XMLSCHEMA
 XMLDECLARATION
+XMLSCHEMA
diff --git a/doc/src/sgml/keywords/sql2011-14-reserved.txt b/doc/src/sgml/keywords/sql2023-14-reserved.txt
similarity index 100%
rename from doc/src/sgml/keywords/sql2011-14-reserved.txt
rename to doc/src/sgml/keywords/sql2023-14-reserved.txt
-- 
2.39.2

